<?php
/*
  $Id: catalog_checkout.php,v 1.14 2006/04/07 02:48:44 devosc Exp $

  AuctionBlox, sell more, work less!
  http://www.auctionblox.com

  Copyright (c) 2004 AuctionBlox
*/

  include_once DIR_FS_ABX_CLASSES.'abxCheckout.php';
  include_once DIR_FS_ABX_CLASSES.'abxCustomer.php';

  class abxModule_Catalog_Checkout extends abxModule {

    function abxModule_Catalog_Checkout() {
      if (!empty($_GET['checkout'])
            || (!empty($_POST['perform']) && $_POST['perform'] == 'process')) {
        $this->process();
      }
    }

    function process() {
      global $navigation, $language;

      abx_includeLanguageFile(DIR_FS_MYABX, $language, 'catalog_checkout');

      $email_address = $_GET['checkout'];
      if (!empty($_POST['email'])) {
        $email_address = $_POST['email'];
      };

      // Check if email exists
      $abxCheckout = new abxCheckout();

      $auctions = $abxCheckout->getSales($email_address);

      if (empty($auctions)) {
        define('AUCTIONBLOX_CHECKOUT_ERROR', TEXT_AUCTION_FINDER_ERROR);
      } elseif (!$abxCheckout->canCheckout($auctions)) {
        define('AUCTIONBLOX_CHECKOUT_ERROR', TEXT_AUCTION_INVALID_ERROR);
      } else {
        $Customer = new abxCustomer($email_address);

        if ($Customer->isAuctionBloxRequest($_POST))
        {
		  	  if( $Customer->hasBuyerInfo() )
          {
            if( !$Customer->exists() )
            {
		              $Customer->create();
		              $Customer->doLogin();
                      
                  if(defined('WELCOME_EMAIL_ENABLED') && constant('WELCOME_EMAIL_ENABLED') === 'true')
                  {
                    $email_text = WELCOME_EMAIL_INTRODUCTION_PARAGRAPH .
                                  sprintf(WELCOME_EMAIL_PASSWORD_PARAGRAPH, $Customer->sPwd) .
                                  WELCOME_EMAIL_CONCLUSION_PARAGRAPH .
                                  WELCOME_EMAIL_SIGNATURE;
                    
                    tep_mail($Customer->name, 
                             $Customer->sEmail,
                             WELCOME_EMAIL_TITLE, 
                             $email_text, 
                             STORE_OWNER, 
                             STORE_OWNER_EMAIL_ADDRESS);
                }
		        }
	          else
	          {
                  $Customer->update();
	                $Customer->doLogin();
	          }
          }    
        }

        $_SESSION['g_auction_email_address'] = $email_address;
        $_SESSION['g_auction_house'] = $auctions[0]['auction_house_label'];
        
        // PHP5 fix - Contributed by Tony Lam
        // This is what I added to make sure that session information get written 
        // to the database before abxDatabase_MySQL class disconnect close the MYSQL connection
        session_write_close(); 

        $navigation->remove_current_page();

        abxPage::redirect(abx_href_link(FILENAME_SHOPPING_CART, '', 'SSL'));
      }
    }

    function display() {
      global $breadcrumb, $language, $request_type;

      $page = new abxPage_Catalog();
      $page->setContentFile('catalog_checkout', DIR_FS_MYABX_PAGES_DIR);

      abx_includeLanguageFile(DIR_FS_MYABX, $language, 'catalog_checkout');

      $page->setTitle(TITLE);
      $page->setOnLoad('document.auctionblox.email.focus();');

      $breadcrumb->add(NAVBAR_TITLE_CHECKOUT, abx_href_link(FILENAME_AUCTIONBLOX, '', 'SSL'));
      $breadcrumb->add(NAVBAR_TITLE, abx_href_link(FILENAME_AUCTIONBLOX, '', 'SSL'));

      define('AUCTIONBLOX_CHECKOUT_FORM',
          $page->form('auctionblox', FILENAME_AUCTIONBLOX, '', 'post', '', 'SSL').
          '<input type="hidden" name="perform" value="process"/>');

      define('AUCTIONBLOX_SUBMIT_BUTTON', abx_image_submit('button_continue.gif', IMAGE_BUTTON_CONTINUE));

      define('AUCTIONBLOX_POWERED_LOGO', sprintf(
        '<a href="http%s://www.auctionblox.com" target="_blank"><img src="includes/modules/auctionblox/images/abx.gif" border="0" width="90" height="20" alt="Powered by AuctionBlox.com" title="Powered by AuctionBlox.com" /></a>',
        $request_type === 'SSL' ? 's' : '')
      );

      return $page;
    }

  }//end class
?>