<?php
/*
  $Id: PAYFLOWLINK.php,v 1.0 2002/05/10 01:22:51 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2002 osCommerce

  Released under the GNU General Public License
*/
  class payflowlink {
    var $code, $title, $description, $enabled;

// class constructor
    function payflowlink() {
      $this->code = 'payflowlink';
      $this->title = MODULE_PAYMENT_PAYFLOWLINK_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_PAYFLOWLINK_TEXT_DESCRIPTION;
      $this->enabled = MODULE_PAYMENT_PAYFLOWLINK_STATUS;
      $this->form_action_url = 'https://payments.verisign.com/payflowlink';
    }

// class methods
    function javascript_validation() {
      $validation_string = 'else if (payment_value == "' . $this->code . '") {' . "\n" .
                           '  var cc_number = document.checkout_payment.payflowlink_cc_number.value;' . "\n" .
                           '  if (cc_number == "" || cc_number.length < ' . CC_NUMBER_MIN_LENGTH . ') {' . "\n" .
                           '    error_message = error_message + "' . MODULE_PAYMENT_PAYFLOWLINK_TEXT_JS_CC_NUMBER . '";' . "\n" .
                           '    error = 1;' . "\n" .
                           '  }' . "\n" .
                           '}' . "\n" ;
     if (MODULE_PAYMENT_PAYFLOWLINK_CSC=="1"){
      $validation_string .=  'if (payment_value== "' . $this->code . '" && document.checkout_payment.payflowlink_cc_csc.value==""){ ' . "\n" .
                           '  error_message = error_message + " You must provide a CSC ";' . "\n".
                           ' error=1;} ' . "\n";}
      return $validation_string;
    }

    function selection() {
      global $order;
      for ($i=1; $i < 13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%m',mktime(0,0,0,$i,1,2000)));
      }

      $today = getdate();
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }
      $fields[0]=array('title' => '</td><tr><td colspan=8 class=main><B>'.MODULE_PAYMENT_PAYFLOWLINK_TEXT_TITLE1.'<a href="'.tep_href_link(FILENAME_PRIVACY, '', 'NONSSL').'">'. MODULE_PAYMENT_PAYFLOWLINK_TEXT_TITLE2 .'</a> </B>' ,
                       'field' => '</td>');
                       
      $fields[1]=array('title' => MODULE_PAYMENT_PAYFLOWLINK_TEXT_CREDIT_CARD_NUMBER,
                       'field' => tep_draw_input_field('payflowlink_cc_number','','valign=Center') .'&nbsp'.
                                     tep_image(DIR_WS_IMAGES.'cclogos.gif'));

       $fields[2]=array('title' =>  MODULE_PAYMENT_PAYFLOWLINK_TEXT_CREDIT_CARD_EXPIRES ,
                          'field' => tep_draw_pull_down_menu('payflowlink_cc_expires_month', $expires_month) . '&nbsp;&nbsp;' . tep_draw_pull_down_menu('payflowlink_cc_expires_year', $expires_year));

     if (MODULE_PAYMENT_PAYFLOWLINK_CSC=="1"){
       $fields[3]=array('title' =>  MODULE_PAYMENT_PAYFLOWLINK_TEXT_CREDIT_CARD_CSC,
                          'field' => '<table border="0" cellpadding="2" cellspacing="1" style="border-collapse: collapse" bordercolor="#111111" width="100%" height="100%">'.
                          '<tr><td >'.tep_draw_input_field('payflowlink_cc_csc','','size="4" maxlenght="4" valign="center"') . '&nbsp;</td>'.
                          '<td  valign="center"><a href=javascript:{}; onclick="javascript:{window.open(\'./csc.htm\',\'test\',\'height=550,width=800,top=100,left=100\');false}">'.tep_image(DIR_WS_IMAGES.'csc.gif').'</a></td>'.
                          '<td><table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%"></td>'.
                          '<td class="main" >'.MODULE_PAYMENT_PAYFLOWLINK_TEXT_CREDIT_CARD_CSC_TEXT.'</td>'.
                          '<td class="main" ><a href=javascript:{}; onclick="javascript:{window.open(\'./csc.htm\',\'test\',\'height=550,width=800,top=100,left=100\');false}">'.MODULE_PAYMENT_PAYFLOWLINK_TEXT_CREDIT_CARD_CSC_HELP.'</a></td>'.
                          '<td class="main" >&nbsp;|&nbsp;</td>'.
                          '<td class="main" align="left"><a href=javascript:{}; onclick="javascript:{window.open(\'./csc_amex.htm\',\'test\',\'height=550,width=800,top=100,left=100\');false}">'.MODULE_PAYMENT_PAYFLOWLINK_TEXT_CREDIT_CARD_CSC_AMEX.'</a></td>'.
                          '</tr></table></tr></table>');}


      $selection = array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => $fields);
      return $selection;

    }

    function pre_confirmation_check() {
      global $payment, $HTTP_POST_VARS;

      include(DIR_WS_CLASSES . 'cc_validation.php');

      $cc_validation = new cc_validation();
      $result = $cc_validation->validate($HTTP_POST_VARS['payflowlink_cc_number'], $HTTP_POST_VARS['payflowlink_cc_expires_month'], $HTTP_POST_VARS['payflowlink_cc_expires_year']);

      $error = '';
      switch ($result) {
        case -1:
          $error = sprintf(TEXT_CCVAL_ERROR_UNKNOWN_CARD, substr($cc_validation->cc_number, 0, 4));
          break;
        case -2:
        case -3:
        case -4:
          $error = TEXT_CCVAL_ERROR_INVALID_DATE;
          break;
        case false:
          $error = TEXT_CCVAL_ERROR_INVALID_NUMBER;
          break;
      }

      //$cc_val = OnlyNumericSolution($HTTP_POST_VARS['payflowlink_cc_number']);
      //$cc_val = CCValidationSolution($cc_val);
      //if ($cc_val == '1') $cc_val = ValidateExpiry($HTTP_POST_VARS['payflowlink_cc_expires_month'], $HTTP_POST_VARS['payflowlink_cc_expires_year']);
      if ( ($result == false) || ($result < 1) ) {
        $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) .  '&cc_expires_month=' .$HTTP_POST_VARS['payflowlink_cc_expires_month'].  '&shipping_selected=' . $HTTP_POST_VARS['shipping_selected'] . '&cc_expires_year=' . $HTTP_POST_VARS['payflowlink_cc_expires_year'];

        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }

      $this->cc_card_type = $cc_validation->cc_type;
      $this->cc_card_number = $cc_validation->cc_number;
      $this->cc_expiry_month = $cc_validation->cc_expiry_month;
      $this->cc_expiry_year = $cc_validation->cc_expiry_year;
    }

    function confirmation() {
      global $HTTP_POST_VARS, $CardName, $CardNumber, $checkout_form_action;


      $fields[0]=array('title' => MODULE_PAYMENT_PAYFLOWLINK_TEXT_CREDIT_CARD_NUMBER ,
                       'field' => $this->cc_card_number );
     if (MODULE_PAYMENT_PAYFLOWLINK_CSC=="1"){
      $fields[1]=array('title' => MODULE_PAYMENT_PAYFLOWLINK_TEXT_CREDIT_CARD_CSC ,
                       'field' => $HTTP_POST_VARS['payflowlink_cc_csc'] );
     }else{
      $fields[1]=array('title' => '' ,
                       'field' => '' );
     }
      $fields[2]=array('title' => MODULE_PAYMENT_PAYFLOWLINK_TEXT_CREDIT_CARD_EXPIRES ,
                       'field' => strftime('%B/%Y', mktime(0,0,0,$HTTP_POST_VARS['payflowlink_cc_expires_month'], 1, '20' . $HTTP_POST_VARS['payflowlink_cc_expires_year'])) );

      $confirmation = array('title' => $this->title . ': ' . $this->cc_card_type,
                            'fields' => $fields);

      return $confirmation;

    }

    function process_button() {
      global $HTTP_POST_VARS, $CardName, $CardNumber, $order, $total_tax, $shipping_cost;
      if (strlen($HTTP_POST_VARS['payflowlink_cc_first_name']) && strlen($HTTP_POST_VARS['payflowlink_cc_last_name'])){
      $Name = $HTTP_POST_VARS['payflowlink_cc_first_name']. ' ' . $HTTP_POST_VARS['payflowlink_cc_last_name']; }else{
      $Name = $order->customer['firstname'] . ' ' . $order->customer['lastname'];
      }
      $process_button_string = tep_draw_hidden_field('LOGIN',MODULE_PAYMENT_PAYFLOWLINK_LOGIN).
                               tep_draw_hidden_field('PARTNER',MODULE_PAYMENT_PAYFLOWLINK_PARTNER).
                               tep_draw_hidden_field('TYPE',MODULE_PAYMENT_PAYFLOWLINK_TYPE) .
                               tep_draw_hidden_field('EXPDATE', $this->cc_expiry_month . $this->cc_expiry_year) .
                               tep_draw_hidden_field('AMOUNT', number_format($order->info['total'], 2, '', '')).
                               tep_draw_hidden_field('SHIPAMOUNT', number_format($order->info['shipping_cost'], 2, '', '')).
                               tep_draw_hidden_field('TAX', number_format($order->info['tax'], 2, '', '')).
                               tep_draw_hidden_field('CARDNUM', $this->cc_card_number);
     if (MODULE_PAYMENT_PAYFLOWLINK_CSC=="1"){
        $process_button_string .= tep_draw_hidden_field('CSC', $HTTP_POST_VARS['payflowlink_cc_csc']);
     }
      $process_button_string .= tep_draw_hidden_field('NAME', $Name) .
                               tep_draw_hidden_field('ADDRESS', $order->customer['street_address']) .
                               tep_draw_hidden_field('CITY', $order->customer['city']) .
                               tep_draw_hidden_field('STATE', $order->customer['state']) .
                               tep_draw_hidden_field('ZIP', $order->customer['postcode']) .
                               tep_draw_hidden_field('COUNTRY', $order->customer['country']['title']) .
                               tep_draw_hidden_field('PHONE', $order->customer['telephone']) .
                               tep_draw_hidden_field('EMAIL', $order->customer['email_address']) .
                               tep_draw_hidden_field('NAMETOSHIP', $order->delivery['firstname'] . ' ' . $order->delivery['lastname']) .
                               tep_draw_hidden_field('ADDRESSTOSHIP', $order->delivery['street_address']) .
                               tep_draw_hidden_field('CITYTOSHIP', $order->delivery['city']) .
                               tep_draw_hidden_field('STATETOSHIP', $order->delivery['state']) .
                               tep_draw_hidden_field('ZIPTOSHIP', $order->delivery['postcode']) .
                               tep_draw_hidden_field('COUNTRYTOSHIP', $order->delivery['country']['title']) .
                               tep_draw_hidden_field('METHOD', MODULE_PAYMENT_PAYFLOWLINK_METHOD) .
                               tep_draw_hidden_field('ECHODATA', 'True') .
                               tep_draw_hidden_field('ORDERFORM', 'False') .
                               tep_draw_hidden_field('SHOWCONFIRM', 'False') .
                               tep_draw_hidden_field('USER1',tep_session_name()) .
                               tep_draw_hidden_field('USER2',tep_session_id()) .
                               tep_draw_hidden_field(tep_session_name(),tep_session_id());
      return $process_button_string;
    }

    function before_process() {
      global $HTTP_GET_VARS;
      $response = trim($HTTP_GET_VARS['RESULT']) ;
      $responsemsg = $HTTP_GET_VARS['RESPMSG'] ;
      while (list ($key, $val) = each ($HTTP_GET_VARS)) {
        $getparameters .= $key.'='.urlencode($val).'&';
      }

        if ($response!=0) {
                tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode($responsemsg), 'SSL', true, false));
        }

    }

    function after_process() {
          return false;
    }

/*    function output_error() {
      global $HTTP_GET_VARS;

      $output_error_string = '<table border="0" cellspacing="0" cellpadding="0" width="100%">' . "\n" .
                             '  <tr>' . "\n" .
                             '    <td class="main">&nbsp;<font color="#FF0000"><b>' . MODULE_PAYMENT_PAYFLOWLINK_TEXT_ERROR . '</b></font><br>&nbsp;' . stripslashes($HTTP_GET_VARS['cc_val']) . '&nbsp;</td>' . "\n" .
                             '  </tr>' . "\n" .
                             '</table>' . "\n";

      return $output_error_string;
    }*/
    function get_error() {
      global $HTTP_GET_VARS;

      $error = array('title' => MODULE_PAYMENT_PAYFLOWLINK_TEXT_ERROR,
                     'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));

      return $error;
    }

    function check() {
      if (!isset($this->check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYFLOWLINK_STATUS'");
        $this->check = tep_db_num_rows($check_query);
      }
      return $this->check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Allow PayflowLink?', 'MODULE_PAYMENT_PAYFLOWLINK_STATUS', '1', 'Do you want to accept Playfowlink payments?', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Currency', 'MODULE_PAYMENT_PAYFLOWLINK_CURRENCY', 'USD', 'Currency', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PayflowLink Transaction Type', 'MODULE_PAYMENT_PAYFLOWLINK_TYPE', 'S', 'Indicates type of transaction effecting the cardholders account (S = sale)', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PayflowLink Transaction Method', 'MODULE_PAYMENT_PAYFLOWLINK_METHOD', 'CC', 'Indicates type of tender being used (CC = credit card)', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PayflowLink Partner', 'MODULE_PAYMENT_PAYFLOWLINK_PARTNER', 'PartnerId', 'VeriSign Your partner ID is provided to you by the authorized VeriSign Reseller who signed you up for the PayflowLink service. If you signed up yourself, use VeriSign.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PayflowLink Login', 'MODULE_PAYMENT_PAYFLOWLINK_LOGIN', 'login', 'Your case-sensitive login that you defined at registration.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('CSC', 'MODULE_PAYMENT_PAYFLOWLINK_CSC', '1', 'Allow CSC', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYFLOWLINK_STATUS'");
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYFLOWLINK_CURRENCY'");
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYFLOWLINK_TYPE'");
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYFLOWLINK_METHOD'");
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYFLOWLINK_PARTNER'");
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYFLOWLINK_LOGIN'");
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYFLOWLINK_CSC'");
    }

    function keys() {
      $keys = array('MODULE_PAYMENT_PAYFLOWLINK_STATUS', 'MODULE_PAYMENT_PAYFLOWLINK_CURRENCY',  'MODULE_PAYMENT_PAYFLOWLINK_TYPE', 'MODULE_PAYMENT_PAYFLOWLINK_METHOD', 'MODULE_PAYMENT_PAYFLOWLINK_PARTNER','MODULE_PAYMENT_PAYFLOWLINK_LOGIN', 'MODULE_PAYMENT_PAYFLOWLINK_CSC');

      return $keys;
    }
  }
?>
