<?php

/**
 * 
 *
 * @version $Id$
 * @copyright 2003 
 **/

// Don't timeout while processing
ini_set("max_execution_time", "0"); 
ini_set("upload_max_filesize", "8M");



//Settings for inserting local files
$del_local = ";";    //the delimiter character of your local csv file - either ; or ,
$format_local = "1.000,00";  // the price format your TurboLister inserts into the csv file - either 1.000,00 or 1,000.00




// **** Temp directory ****
// if you changed your directory structure from stock and do not have /catalog/temp/, then you'll need to change this accordingly.
//
$tempdir = "temp/";
$tempdir2 = "/temp/";

global $separator;
$separator = ",";

require('includes/application_top.php');
 require(DIR_WS_CLASSES . 'currencies.php');
  $currencies = new currencies();  

  require(DIR_WS_CLASSES . 'auction_lister.php');
  $auctionLister = new AuctionLister();
  
  require(DIR_WS_CLASSES . 'auction_constants.php');
  $auctionConstants = new auctionConstants;


if ( $download == 'stream' or  $download == 'tempfile' ){
echo 'You want to download... wait til it\'s finished';
}


?>

<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="#FFFFFF">
<?php require(DIR_WS_INCLUDES . 'header.php'); ?>

<table border="0" width="100%" cellspacing="2" cellpadding="2">
<tr>
<td width="<?php echo BOX_WIDTH; ?>" valign="top" height="27">
<table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="1" cellpadding="1" class="columnLeft">
<?php require(DIR_WS_INCLUDES . 'column_left.php');?>
</table></td>
<td  valign="top"><?php
echo 'EAM Import from Turbo Lister<br><br>If you want to upload and insert auction items into your databse from a file on your harddisk, choose "Upload File".<br>';
echo 'If you want to insert auction items into the database from a file on your webserver, choose the link below "local csv file found". Copy your csv file created by TurboLister to catalog/temp/ and the script will find it itself.<br><br>' ;

if (($_REQUEST['localfile'] && $split == 0 ) or (is_uploaded_file($usrfl) && $split == 0 )) {

	if ($usrfl){
		// move the file to where we can work with it
		$file = tep_get_uploaded_file('usrfl');
		if (is_uploaded_file($file['tmp_name'])) {
			tep_copy_uploaded_file($file, DIR_FS_DOCUMENT_ROOT . $tempdir);
		}
	
		echo "<p class=smallText>";
		echo "File uploaded. <br>";
		echo "Temporary filename: " . $usrfl . "<br>";
		echo "User filename: " . $usrfl_name . "<br>";
		echo "Size: " . $usrfl_size . "<br>";
	
		// get the entire file into an array
		$csv=new CSVparse();
		$rawlistings=$csv->parse_file(DIR_FS_DOCUMENT_ROOT . $tempdir . $usrfl_name, $HTTP_POST_VARS['delimiter']);
		$format = $HTTP_POST_VARS['format'];
	
		/*echo '<pre>';
		print_r($readed);
		echo '</pre>';*/
		foreach($rawlistings as $listing){
			$translatedlisting=array();
			foreach($listing as $key=>$val){
			$val=str_replace('~','' ,$val );
			$listing[$key]=$val;
			}
			
			if ($listing['Accept Money Xfer'] == '1') { $discover = $listing['Accept Money Xfer']; } else { $discover = $listing['Accept Discover']; }
			if ($listing['Payment See Description'] == '1') { $payment_other = $listing['Payment See Description']; } else { $payment_other = $listing['Accept Payment Other']; }
			if ($listing['CCAccepted'] == '1') { $creditcard = $listing['CCAccepted']; } else { $creditcard = $listing['Accept Visa/Mastercard']; }
			if ($listing['Specifying Shipping Costs'] != '') { $shipping_type = $listing['Specifying Shipping Costs']; } else { $shipping_type = $listing['ShippingType']; }
			
			$translatedlisting = array('title' => $listing['Title'],
	                           'subtitle' => $listing['SubtitleText'],
				   'site' => convertSite($listing['Site']),
				   'region' => $listing['Location - Region'],
				   'city_state' => $listing['Location - City/State'],
				   'country' => $listings['Location - Country'],
	                           'listing_type' => $listing['Format'],
	                           'store_category' => $listing['Store Category'],
	                           'category1' => $listing['Category 1'],
	                           'category2' => $listing['Category 2'],
	                           'duration' => $listing['Duration'],
				   'picture1_url' => $listing['PhotoOneURL'],
				   'picture2_url' => tep_db_prepare_input($vars['picture2_url']),
				   'picture3_url' => tep_db_prepare_input($vars['picture3_url']),
				   'picture4_url' => tep_db_prepare_input($vars['picture4_url']),
				   'picture5_url' => tep_db_prepare_input($vars['picture5_url']),
				   'picture6_url' => tep_db_prepare_input($vars['picture6_url']),
				   'picture7_url' => tep_db_prepare_input($vars['picture7_url']),
				   'picture8_url' => tep_db_prepare_input($vars['picture8_url']),
	                           'quantity' => $listing['Quantity'],
	                           'price' => convertPrice($format, $listing['Starting Price']),
	                           'bin_price' => convertPrice($format, $listing['BIN Price']),
	                           'reserve_price' => convertPrice($format, $listing['Reserve Price']),
	                           'currency' => convertCurrency($listing['Currency']),
	                           'paypal_accepted' => $listing['Accept PayPal'],
	                           'paypal_immediate_pay' => $listing['AutoPay'],
	                           'paypal_email' => $listing['PayPal Email Address'],
	                           'payment_mastercard_visa' => $creditcard,
	                           'payment_cod' => $listing['Accept COD'],
	                           'payment_other' => $payment_other,
	                           'payment_amex' => $listing['Accept AmEx'],
	                           'payment_discover' => $discover,
	                           'payment_moneyorder_cashiers' => $listing['Accept MO Cashiers'],
	                           'payment_description' => $listing['Payment Instructions'],
	                           'sales_tax_state' => $listing['Sales Tax State'],
	                           'sales_tax_percent' => convertPrice($format, $listing['Sales Tax Amount']),
	                           'sales_tax_sandh' => $listing['Apply tax to total'],
	                           'shipping_type' => convertShippingType($shipping_type),
	                           'shipping_location' => convertShippingOption($listing['Ship-To Option']),
	                           'shipping' => $listing['Shipping & Handling'],
	                           'shipping_addl' => $listing['Additional Shipping'],
	                           'insurance_option' => $listing['Insurance Option'],
	                           'insurance' => $listing['Insurance Amount'],
	//			   'shipping_description' => tep_db_prepare_input($vars['shipping_description']),
				   'extra_private' =>$listing['Private Auction'],
				   'extra_bold' => $listing['Bold'],
				   'extra_highlight' => $listing['Highlight'],
				   'extra_gallery' => convertGallery($listing['Gallery'], $listing['Gallery Featured']),
				   'extra_gallery_url' => $listing['Gallery URL'],
				   'extra_category_featured' =>$listing['Gallery Featured'],
				   'extra_homepage_featured' => $listing['Home Page Featured'],
				   'counter' => $listing['Counter'],
				   'description' => $listing['Description'],
				   'products_id' => tep_db_prepare_input($vars['products_id']),
				   'last_modified' => 'now()');
		
				$id = $auctionLister->insertListing($translatedlisting);
				echo 'you inserted with id '.$id.'<br>';
		}
	
	}
	if($_REQUEST['localfile']){
//		$delimiter = str_replace('1', ';', $_REQUEST['delimiter']);    // replaced with variables on top of the file
//		$format = str_replace('1', '1.000,00', $_REQUEST['format']);
		$delimiter = $del_local;
		$format = $format_local;
	        // get the entire file into an array
	        $csv = new CSVparse();
	        $rawlistings = $csv->parse_file(DIR_FS_DOCUMENT_ROOT . $tempdir . $_REQUEST['localfile'], $delimiter);
	
	
		foreach($rawlistings as $listing){
			$translatedlisting=array();
			foreach($listing as $key=>$val){
			$val=str_replace('~','' ,$val );
			$listing[$key]=$val;
			}
			
			if ($listing['Accept Money Xfer'] == '1') { $discover = $listing['Accept Money Xfer']; } else { $discover = $listing['Accept Discover']; }
			if ($listing['Payment See Description'] == '1') { $payment_other = $listing['Payment See Description']; } else { $payment_other = $listing['Accept Payment Other']; }
			if ($listing['CCAccepted'] == '1') { $creditcard = $listing['CCAccepted']; } else { $creditcard = $listing['Accept Visa/Mastercard']; }
			if ($listing['Specifying Shipping Costs'] != '') { $shipping_type = $listing['Specifying Shipping Costs']; } else { $shipping_type = $listing['ShippingType']; }
			
			$translatedlisting = array('title' => $listing['Title'],
                	           'subtitle' => $listing['SubtitleText'],
				   'site' => convertSite($listing['Site']),
				   'region' => $listing['Location - Region'],
				   'city_state' => $listing['Location - City/State'],
				   'country' => $listings['Location - Country'],
                	           'listing_type' => $listing['Format'],
                	           'store_category' => $listing['Store Category'],
                	           'category1' => $listing['Category 1'],
                	           'category2' => $listing['Category 2'],
                	           'duration' => $listing['Duration'],
				   'picture1_url' => $listing['PhotoOneURL'],
				   'picture2_url' => tep_db_prepare_input($vars['picture2_url']),
				   'picture3_url' => tep_db_prepare_input($vars['picture3_url']),
				   'picture4_url' => tep_db_prepare_input($vars['picture4_url']),
				   'picture5_url' => tep_db_prepare_input($vars['picture5_url']),
				   'picture6_url' => tep_db_prepare_input($vars['picture6_url']),
				   'picture7_url' => tep_db_prepare_input($vars['picture7_url']),
				   'picture8_url' => tep_db_prepare_input($vars['picture8_url']),
                	           'quantity' => $listing['Quantity'],
                	           'price' => convertPrice($format, $listing['Starting Price']),
                	           'bin_price' => convertPrice($format, $listing['BIN Price']),
                	           'reserve_price' => convertPrice($format, $listing['Reserve Price']),
                	           'currency' => convertCurrency($listing['Currency']),
                	           'paypal_accepted' => $listing['Accept PayPal'],
                	           'paypal_immediate_pay' => $listing['AutoPay'],
                	           'paypal_email' => $listing['PayPal Email Address'],
                	           'payment_mastercard_visa' => $creditcard,
                	           'payment_cod' => $listing['Accept COD'],
                	           'payment_other' => $payment_other,
                	           'payment_amex' => $listing['Accept AmEx'],
                	           'payment_discover' => $discover,
                	           'payment_moneyorder_cashiers' => $listing['Accept MO Cashiers'],
                	           'payment_description' => $listing['Payment Instructions'],
                	           'sales_tax_state' => $listing['Sales Tax State'],
                	           'sales_tax_percent' => convertPrice($format, $listing['Sales Tax Amount']),
                	           'sales_tax_sandh' => $listing['Apply tax to total'],
                	           'shipping_type' => convertShippingType($shipping_type),
                	           'shipping_location' => convertShippingOption($listing['Ship-To Option']),
                	           'shipping' => $listing['Shipping & Handling'],
                	           'shipping_addl' => $listing['Additional Shipping'],
                	           'insurance_option' => $listing['Insurance Option'],
                	           'insurance' => $listing['Insurance Amount'],
//				   'shipping_description' => tep_db_prepare_input($vars['shipping_description']),
				   'extra_private' =>$listing['Private Auction'],
				   'extra_bold' => $listing['Bold'],
				   'extra_highlight' => $listing['Highlight'],
				   'extra_gallery' => convertGallery($listing['Gallery'], $listing['Gallery Featured']),
				   'extra_gallery_url' => $listing['Gallery URL'],
				   'extra_category_featured' =>$listing['Gallery Featured'],
				   'extra_homepage_featured' => $listing['Home Page Featured'],
				   'counter' => $listing['Counter'],
				   'description' => $listing['Description'],
				   'products_id' => tep_db_prepare_input($vars['products_id']),
				   'last_modified' => 'now()');
	
			$id = $auctionLister->insertListing($translatedlisting);
			echo 'you inserted with id '.$id.'<br>';
		}
	}
}
if (($_REQUEST['localfile'] && $split == 1) or (is_uploaded_file($usrfl) && $split == 1)) {
	if($_REQUEST['localfile']){
		echo '<br>localfile split not done yet';
	}
	if ($usrfl){
		echo '<br>userfile Split not done yet';
	}
}
	               
function convertSite($input)
{
	$data = array(
			'0' => 'US',
			'2' => 'CA',
			'3' => 'UK',
			'15' => 'AU',
			'16' => 'AT',
//			'23' => 'BEFR',
			'71' => 'FR',
			'77' => 'DE',
			'101' => 'IT',
//			'123' => 'BENL',
//			'146' => 'NL',
			'186' => 'ES',
			'193' => 'CH',
			'196' => 'TW',
			'100' => 'EMO');
			
	return $data[$input];
}

function convertCurrency($input)
{
	$data = array(
			'1' => 'USD',
			'2' => 'CAD',
			'3' => 'GDP',
			'5' => 'AUD',
			'7' => 'EUR',
			'13' => 'CHF');
			
	return $data[$input];
}

function convertShippingType($input)
{
	$data = array(
			'0' => 'C',
			'1' => 'F',
			'2' => 'C');
			
	return $data[$input];
}

function convertShippingOption($input)
{
	$data = array(
			'SiteOnly' => 'D',
			'WorldWide' => 'I',
			'SitePlusRegions' => 'D',
			'WillNotShip' => 'N');
			
	return $data[$input];
}

function convertPrice($format, $input)
{
	if($format == "1.000,00")
	{
		return str_replace(",", ".", $input);
	}
	else
	{
		return $input;
	}
}

function convertGallery($gallery, $galleryFeatured)
{
	if($gallery == "1")
		return 'G';
	else if($galleryFeatured == "1")
		return 'F';
	else
		return 'N';
}
?>

<p class="smallText">

</p>

      <table width="75%" border="2">
        <tr>
          <td width="75%">
           <FORM ENCTYPE="multipart/form-data" ACTION="auction_import_tl.php" METHOD=POST>
              <p>
                <div align = "left">
                <p><b>Upload File</b></p>
                  <INPUT TYPE="hidden" name="MAX_FILE_SIZE" value="100000000">                
                <table border=0 class=smalltext>
		  <tr><td>Please enter the delimiter character of your csv file here:
                  </td><td>
                  <input name="delimiter" type="text" maxlength="1" size="3" value=";"></td></tr>
                  <tr><td>Please choose your price format here:<br>(Like it is stored in the csv file)</td>
                  <td><select name="format"><option>1.000,00</option><option>1,000.00</option>
                  </select></td></tr>
                  <tr><td>Please select your csv file:</td><td><input name="usrfl" type="file" size="50"></td></tr>
                  <tr><td colspan=2 align=center><br><br><input type="submit" name="buttoninsert" value="Upload File and insert items into database"></td></tr></table>
              </div>

              </form>
	  </td>
	</tr>
        <tr>
          <td width="75%">
           <FORM ENCTYPE="multipart/form-data" ACTION="auction_import_tl.php?split=0" METHOD=POST>
		<p>
                <div align = "left">
                <p><b>Insert Local File</b></p>
                <p>You can insert the items from a csv file created by TurboLister. This file has to reside in /catalog/temp/ .<br>
		Simply click on one file, wait until it is inserted into database and then choose the next one (if there is one).<br>
		NOTE: This script does not check if your items are in your database or not - so you will have double entries when inserting twice.<br><br>
		<br>
                  <INPUT TYPE="hidden" name="MAX_FILE_SIZE" value="1000000000">
                <table border=0 class=smalltext>
		  <tr><td>Please enter the delimiter character of your csv file here:
                  </td><td>
                  <input name="delimiter" type="text" maxlength="1" size="3" value=";"></td></tr>
                  <tr><td>Please choose your price format here:<br>(Like it is stored in the csv file)</td>
                  <td><select name="format"><option>1.000,00</option><option>1,000.00</option>
                  </select></td></tr>
                  <tr><td>Please select your csv file:</td><td>
<?php
			$dir = dir(DIR_FS_DOCUMENT_ROOT . $tempdir);
			while ($file = $dir->read()) {
			    if (($file != '.') && ($file != 'CVS') && ($file != '..')) {
			        if (strpos($file, '.csv') !== false) {
			
			            echo tep_draw_radio_field('localfile', $file);
			            echo $file?><br>
				<?php
			        } 
			    } 
			} 

?>                  
                  
                  </td></tr>
                  <tr><td colspan=2 align=center><br><br><input type="submit" name="buttonsplit" value="Split file"></td></tr></table>
                </p>
              </div>

              </form>
	  </td>
	</tr>

</table>
</body>
</html>

<?php


function tep_get_uploaded_file($filename) {
	if (isset($_FILES[$filename])) {
		$uploaded_file = array('name' => $_FILES[$filename]['name'],
		'type' => $_FILES[$filename]['type'],
		'size' => $_FILES[$filename]['size'],
		'tmp_name' => $_FILES[$filename]['tmp_name']);
	} elseif (isset($GLOBALS['HTTP_POST_FILES'][$filename])) {
		global $HTTP_POST_FILES;

		$uploaded_file = array('name' => $HTTP_POST_FILES[$filename]['name'],
		'type' => $HTTP_POST_FILES[$filename]['type'],
		'size' => $HTTP_POST_FILES[$filename]['size'],
		'tmp_name' => $HTTP_POST_FILES[$filename]['tmp_name']);
	} else {
		$uploaded_file = array('name' => $GLOBALS[$filename . '_name'],
		'type' => $GLOBALS[$filename . '_type'],
		'size' => $GLOBALS[$filename . '_size'],
		'tmp_name' => $GLOBALS[$filename]);
	}

return $uploaded_file;
}

// the $filename parameter is an array with the following elements:
// name, type, size, tmp_name
function tep_copy_uploaded_file($filename, $target) {
	if (substr($target, -1) != '/') $target .= '/';

	$target .= $filename['name'];

	move_uploaded_file($filename['tmp_name'], $target);
}

class CSVparse
  {
  var $mappings = array();

  function parse_file($filename, $delimiter)
  {
    $id = fopen($filename, "r"); //open the file
	$delimitertest = fgets($id, 4096);
	rewind($id);
	
	if ( substr_count($delimitertest, $delimiter)<90) 
	{
		die("<b>Are you using the right delimiter???</b>");
	}   

   $data = fgetcsv($id, filesize($filename), $delimiter); /*This will get us the */
                                              			  /*main column names */
   if(!$this->mappings)
       $this->mappings = $data;

   while($data = fgetcsv($id, filesize($filename), $delimiter))
       {
        if(isset($data[0]))
		 {
		  foreach($data as $key => $value)
               $converted_data[$this->mappings[$key]] = addslashes($value);
           $table[] = $converted_data; /* put each line into */
             }                                /* its own entry in    */
         }                                    /* the $table array    */
   fclose($id); //close file
   
   return $table;
   }
  }
?>