<?php
/*
  $Id: auction_upload.php,v 1.0 2003/12/29 Auctionblox Exp $
 
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com
 
  Copyright (c) 2003 osCommerce
  
  This file is part of the eBay Auction Manager for osCommerce
  http://www.auctionblox.com/oscommerce
 
  Copyright (c) 2003, AuctionBlox.com  
 
  Released under the GNU General Public License
*/

  require('includes/application_top.php');

  require(DIR_WS_CLASSES . 'auction_helper.php');  
  require(DIR_WS_FUNCTIONS . 'formatter.php');  

	switch($HTTP_GET_VARS['action'])
	{
		case '':
	    	$oInfo = new objectInfo(array());
		    $action = 'insert';
			break;
			
		case 'edit':
		  	$productMappings_raw = "select ext_title, products_id, auction_house_id, is_approved from " . TABLE_AUCTION_PRODUCT_MATCHER . " where auction_product_matcher_id = '" . $HTTP_GET_VARS['oID'] . "'";
		  	$productMappings = tep_db_query($productMappings_raw);
			$dbProduct = tep_db_fetch_array($productMappings);

			$oInfo = new objectInfo(array('auction_house_id' => $dbProduct['auction_house_id'],
										  'product_id' => $dbProduct['products_id'],
										  'keywords' => $dbProduct['ext_title'],
										  'isApproved' => $dbProduct['is_approved']));
										  
		    $action = 'update';
			break;
			
		case 'update':
			$dbProduct = array( 'auction_house_id' => tep_db_prepare_input($HTTP_POST_VARS['auction_house_id']),
								'products_id' => tep_db_prepare_input($HTTP_POST_VARS['product_id']),
								'ext_title' => tep_db_prepare_input($HTTP_POST_VARS['keywords']),
								'is_approved' => tep_db_prepare_input($HTTP_POST_VARS['isApproved']));
			tep_db_perform(TABLE_AUCTION_PRODUCT_MATCHER, $dbProduct, 'update', 'auction_product_matcher_id = ' . $HTTP_GET_VARS['oID']);
			tep_redirect(tep_href_link(FILENAME_AUCTION_PRODUCT_MAPPING, tep_get_all_get_params(array('action')), 'SSL'));
			break;
			
		case 'insert':

			$dbProduct = array( 'auction_house_id' => tep_db_prepare_input($HTTP_POST_VARS['auction_house_id']),
								'products_id' => tep_db_prepare_input($HTTP_POST_VARS['product_id']),
								'ext_title' => tep_db_prepare_input($HTTP_POST_VARS['keywords']),
								'is_approved' => tep_db_prepare_input($HTTP_POST_VARS['isApproved']));
			tep_db_perform(TABLE_AUCTION_PRODUCT_MATCHER, $dbProduct);
			tep_redirect(tep_href_link(FILENAME_AUCTION_PRODUCT_MAPPING, tep_get_all_get_params(array('action')), 'SSL'));
			break;
							
		case 'cancel':
		default:	
			break;	
	}
	
	$auction_houses = array();
    $auction_houses_query = tep_db_query("select auction_house_id, auction_house_label from " . TABLE_AUCTION_HOUSES);
	while ($auction_house = tep_db_fetch_array($auction_houses_query))
	{
	    $auction_houses[] = array('id' => $auction_house['auction_house_id'],
   			                      'text' => $auction_house['auction_house_label']);
	}			
  
	$products = array();
	if($HTTP_GET_VARS['action'] === 'edit')
	{
		$products_query = tep_db_query("SELECT products_id, products_name, MATCH (products_name) AGAINST ('" . tep_db_input($oInfo->keywords) . "') FROM " . TABLE_PRODUCTS_DESCRIPTION . " WHERE MATCH (products_name) AGAINST ('" . tep_db_input($oInfo->keywords) . "')");
		while ($product = tep_db_fetch_array($products_query))
		{
		    $products[] = array('id' => $product['products_id'],
       			                'text' => $product['products_name']);
  		}		
	}
	
	if(sizeof($products) == 0)		
	{
		$products_query = tep_db_query("select pd.products_id, pd.products_name from " . TABLE_PRODUCTS_DESCRIPTION . " pd where pd.language_id = '" . $languages_id . "' order by pd.products_name");
		while ($product = tep_db_fetch_array($products_query))
		{
		    $products[] = array('id' => $product['products_id'],
       			                'text' => $product['products_name']);
  		}		
	}
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
<script language="javascript" src="includes/general.js"></script>

<script language="javascript"><!--
function check_form() {
  var error = 0;
  var error_message = "<?php echo JS_ERROR; ?>";

//  var customers_firstname = document.customers.customers_firstname.value;
//  if (customers_firstname == "" || customers_firstname.length < <?php echo ENTRY_FIRST_NAME_MIN_LENGTH; ?>) {
//    error_message = error_message + "<?php echo JS_FIRST_NAME; ?>";
//    error = 1;
//  }
//
  if (error == 1) {
    alert(error_message);
    return false;
  } else {
    return true;
  }
}
//--></script>

</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="#FFFFFF" onload="SetFocus();">
<!-- header //-->
<?php require(DIR_WS_INCLUDES . 'header.php'); ?>
<!-- header_eof //-->

<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>
    <td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="1" cellpadding="1" class="columnLeft">
<!-- left_navigation //-->
<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
<!-- left_navigation_eof //-->
    </table></td>
<!-- body_text //-->
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr>
        <td><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo HEADING_TITLE; ?></td>
            <td class="pageHeading" align="right"><?php echo tep_draw_separator('pixel_trans.gif', HEADING_IMAGE_WIDTH, HEADING_IMAGE_HEIGHT); ?></td>
          </tr>
          <tr>
            <td class="main"><?php echo HEADING_DESCRIPTION; ?></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr><?php echo tep_draw_form('auction_item', FILENAME_AUCTION_PRODUCT_MAPPING_ITEM, tep_get_all_get_params(array('action')) . 'action=' . $action, 'post', 'onSubmit="return check_form();"') . tep_draw_hidden_field('default_address_id', $cInfo->customers_default_address_id); ?>
        <td class="formArea"><table border="0" cellspacing="2" cellpadding="2">
          <tr>
            <td class="main"><?php echo ENTRY_AUCTION_TITLE; ?></td>
            <td class="main"><?php echo tep_draw_input_field('keywords', $oInfo->keywords, 'size="55", maxlength="128"', true); ?></td>
          </tr>
          <tr>
            <td class="main"><?php echo ENTRY_AUCTION_HOUSE; ?></td>
            <td class="main"><?php echo tep_draw_pull_down_menu('auction_house_id', $auction_houses, $oInfo->auction_house_id); ?></td>
          </tr>
          <tr>
            <td class="main"><?php echo ENTRY_PRODUCT; ?></td>
            <td class="main"><?php echo tep_draw_pull_down_menu('product_id', $products, $oInfo->product_id); ?></td>
          </tr>
          <tr>
            <td class="main"><?php echo ENTRY_APPROVED; ?></td>
            <td class="main"><?php echo tep_draw_radio_field('isApproved', '1', true) . '&nbsp;&nbsp;True&nbsp;&nbsp;' . tep_draw_radio_field('isApproved', '0', false) . '&nbsp;&nbsp;False&nbsp;' ?>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr>
        <td align="right" class="main"><?php echo tep_image_submit('button_update.gif', IMAGE_UPDATE) . ' <a href="' . tep_href_link(FILENAME_AUCTION_PRODUCT_MAPPING, tep_get_all_get_params(array('action'))) .'">' . tep_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>'; ?></td>
      </tr></form>
    </table></td>
<!-- body_text_eof //-->
  </tr>
</table>
<!-- body_eof //-->
<!-- footer //-->
<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
<!-- footer_eof //-->
<br>
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>
