<?php
/*
  $Id: auction_upload.php,v 1.0 2003/12/29 Auctionblox Exp $
 
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com
 
  Copyright (c) 2003 osCommerce
  
  This file is part of the eBay Auction Manager for osCommerce
  http://www.auctionblox.com/oscommerce
 
  Copyright (c) 2003, AuctionBlox.com  
 
  Released under the GNU General Public License
*/

  require('includes/application_top.php');

  require(DIR_WS_CLASSES . 'auction_helper.php');  
  require(DIR_WS_FUNCTIONS . 'formatter.php');  

			$auction_houses = array();
		    $auction_houses_query = tep_db_query("select auction_house_id, auction_house_label from " . TABLE_AUCTION_HOUSES);
			while ($auction_house = tep_db_fetch_array($auction_houses_query))
			{
			    $auction_houses[] = array('id' => $auction_house['auction_house_id'],
        			                      'text' => $auction_house['auction_house_label']);
	  		}		
  
			$products = array();
			$products_query = tep_db_query("select pd.products_id, pd.products_name from " . TABLE_PRODUCTS_DESCRIPTION . " pd where pd.language_id = '" . $languages_id . "' order by pd.products_name");			
			while ($product = tep_db_fetch_array($products_query))
			{
			    $products[] = array('id' => $product['products_id'],
        			                'text' => $product['products_name']);
	  		}		
		
			$auction_statuses = array();
			$query_raw = "select status_id, status_label from " . TABLE_AUCTION_SALE_STATUS . " where language_id = '" . $languages_id . "' order by status_id ASC";
  			$query = tep_db_query($query_raw);
			while ($status = tep_db_fetch_array($query)) 
			{
				$auction_statuses[] = array('id' => $status['status_id'],
											'text' => $status['status_label']);
			}
			
			$auctionHelper = new auctionHelper;

			$versions = $auctionHelper->getAPIVersions();
			$actions = $auctionHelper->getAPIActions();
			$insuranceOptions =  $auctionHelper->getInsuranceOptions();

		    $oArray =  array('qty' => 1,
							 'extID' => "1238347372",
							 'extTitle' => 'NEW Green Gizmo with Red Trim NR',
							 'timeEnd' => local_date_to_gmt_date_short(date("Y/m/d H:i:s")),
							 'email' => '{unknownEmail}',
							 'userID' => '{unknownUser}',
							 'userRating' => '53',
							 'userEnabled' => true,
							 'currency' => '1',
							 'priceEnd' => '1.00',
							 'tax' => '0.07',
							 'taxPercent' => '7.0',
							 'shipping' => '3.85',
							 'shippingType' => 'F',
							 'shippingAdditional' => '1.20',
							 'shippingZip' => '27606',
							 'shippingCountry' => 'us',
							 'insurance' => '2.20',
							 'insurancePerItem' => true
							 );

	    	$oInfo = new objectInfo($oArray);
			
  
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
<script language="javascript" src="includes/general.js"></script>

</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="#FFFFFF" onload="SetFocus();">
<!-- header //-->
<?php require(DIR_WS_INCLUDES . 'header.php'); ?>
<!-- header_eof //-->

<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>
    <td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="<?php echo BOX_WIDTH; ?>" cellspacing="1" cellpadding="1" class="columnLeft">
<!-- left_navigation //-->
<?php require(DIR_WS_INCLUDES . 'column_left.php'); ?>
<!-- left_navigation_eof //-->
    </table></td>
<!-- body_text //-->
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr>
        <td><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo HEADING_TITLE; ?></td>
            <td class="pageHeading" align="right"><?php echo tep_draw_separator('pixel_trans.gif', HEADING_IMAGE_WIDTH, HEADING_IMAGE_HEIGHT); ?></td>
          </tr>
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr><form action="<?php echo AUCTIONBLOX_UPLOAD_LINK ?>" method="post">
        <td class="formArea"><table border="0" cellspacing="2" cellpadding="2">
		  <?php echo tep_draw_hidden_field('statusID', $auctionHelper->ENDED); ?>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_PROTOCOL_VERSION; ?></td>
            <td class="main"><?php echo tep_draw_pull_down_menu('version', $versions, $oInfo->version); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_ACTION; ?></td>
            <td class="main"><?php echo tep_draw_pull_down_menu('execute', $actions, $oInfo->execute); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_AUCTION_HOUSE; ?></td>
            <td class="main"><?php echo tep_draw_pull_down_menu('auctionHouseID', $auction_houses, $oInfo->auctionHouseID); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_AUCTION_UPLOAD_PASSWORD; ?></td>
            <td class="main"><?php echo tep_draw_password_field('passcode', $oInfo->password, 'maxlength="32"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_EXT_ID; ?></td>
            <td class="main"><?php echo tep_draw_input_field('extID', $oInfo->extID, 'maxlength="32"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_EXT_TITLE; ?></td>
            <td class="main"><?php echo tep_draw_input_field('extTitle', $oInfo->extTitle, 'size="64" maxlength="64"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_TIME_END; ?></td>
            <td class="main"><?php echo tep_draw_input_field('timeEnd', $oInfo->timeEnd, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_EMAIL_ADDRESS; ?></td>
            <td class="main"><?php echo tep_draw_input_field('email', $oInfo->email, 'maxlength="128"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_USERID; ?></td>
            <td class="main"><?php echo tep_draw_input_field('userID', $oInfo->userID, 'maxlength="64"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_USER_RATING; ?></td>
            <td class="main"><?php echo tep_draw_input_field('userRating', $oInfo->userRating, 'maxlength="10"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_USER_GOOD_STANDING; ?></td>
            <td class="main"><?php echo tep_draw_radio_field('userEnabled', '1', $oInfo->userEnabled) . '&nbsp;&nbsp;True&nbsp;&nbsp;' . tep_draw_radio_field('userEnabled', '0') . '&nbsp;&nbsp;False&nbsp;' ?>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_CURRENCY; ?></td>
            <td class="main"><?php echo tep_draw_input_field('currency', $oInfo->currency, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_PRICE_END; ?></td>
            <td class="main"><?php echo tep_draw_input_field('priceEnd', $oInfo->priceEnd, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_QUANTITY; ?></td>
            <td class="main"><?php echo tep_draw_input_field('qty', $oInfo->qty, 'maxlength="4"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_TAX; ?></td>
            <td class="main"><?php echo tep_draw_input_field('tax', $oInfo->tax, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_TAX_PERCENT; ?></td>
            <td class="main"><?php echo tep_draw_input_field('taxPercent', $oInfo->taxPercent, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_SHIPPING_TYPE; ?></td>
            <td class="main"><?php echo tep_draw_radio_field('shippingType', 'F', $oInfo->shippingType==='F') . '&nbsp;&nbsp;Fixed (eBay-style)&nbsp;&nbsp;' . tep_draw_radio_field('shippingType', 'C', $oInfo->shippingType!=='F') . '&nbsp;&nbsp;osCommerce (default)&nbsp;' ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_SHIPPING; ?></td>
            <td class="main"><?php echo tep_draw_input_field('shipping', $oInfo->shipping, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_SHIPPING_ADDITIONAL; ?></td>
            <td class="main"><?php echo tep_draw_input_field('shippingAdditional', $oInfo->shippingAdditional, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_SHIPPING_ZIP; ?></td>
            <td class="main"><?php echo tep_draw_input_field('shippingZip', $oInfo->shippingZip, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_SHIPPING_COUNTRY; ?></td>
            <td class="main"><?php echo tep_draw_input_field('shippingCountry', $oInfo->shippingCountry, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_INSURANCE; ?></td>
            <td class="main"><?php echo tep_draw_input_field('insurance', $oInfo->insurance, 'maxlength="19"', true); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_INSURANCE_OPTION; ?></td>
            <td class="main"><?php echo tep_draw_pull_down_menu('insuranceOption', $insuranceOptions, $oInfo->insuranceOption); ?></td>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_INSURANCE_PER_ITEM; ?></td>
            <td class="main"><?php echo tep_draw_radio_field('insurancePerItem', '1', $oInfo->insurancePerItem) . '&nbsp;&nbsp;True&nbsp;&nbsp;' . tep_draw_radio_field('insurancePerItem', '0') . '&nbsp;&nbsp;False&nbsp;' ?>
          </tr>
          <tr>
            <td class="main" align="right"><?php echo ENTRY_NOTIFY_CUSTOMER; ?></td>
            <td class="main"><?php echo tep_draw_checkbox_field('notify', "true"); ?></td>
          </tr>		  
        </table></td>
      </tr>
      <tr>
        <td><?php echo tep_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <tr>
        <td align="right" class="main"><?php echo tep_image_submit('button_update.gif', IMAGE_UPDATE) . ' <a href="' . tep_href_link(FILENAME_AUCTION_LISTING, tep_get_all_get_params(array('action'))) .'">' . tep_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>'; ?></td>
      </tr></form>
    </table></td>
<!-- body_text_eof //-->
  </tr>
</table>
<!-- body_eof //-->
<!-- footer //-->
<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
<!-- footer_eof //-->
<br>
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>
