<?php
/*
  $Id: database.php,v 1.23 2003/06/20 00:18:30 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  function tep_db_connect($server = DB_SERVER, $username = DB_SERVER_USERNAME, $password = DB_SERVER_PASSWORD, $database = DB_DATABASE, $link = 'db_link') {
    global $$link;

    if (USE_PCONNECT == 'true') {
      $$link = mysql_pconnect($server, $username, $password);
    } else {
      $$link = mysql_connect($server, $username, $password);
    }

    if ($$link) mysql_select_db($database);

    return $$link;
  }

  function tep_db_close($link = 'db_link') {
    global $$link;

    return mysql_close($$link);
  }

  function tep_db_error($query, $errno, $error) { 
    die('<font color="#000000"><b>' . $errno . ' - ' . $error . '<br><br>' . $query . '<br><br><small><font color="#ff0000">[TEP STOP]</font></small><br><br></b></font>');
  }

  function tep_db_query($query, $link = 'db_link') {
    global $$link, $logger;

    if (defined('STORE_DB_TRANSACTIONS') && (STORE_DB_TRANSACTIONS == 'true')) {
      if (!is_object($logger)) $logger = new logger;
      $logger->write($query, 'QUERY');
    }

    $result = mysql_query($query, $$link) or tep_db_error($query, mysql_errno(), mysql_error());

    if (defined('STORE_DB_TRANSACTIONS') && (STORE_DB_TRANSACTIONS == 'true')) {
      if (mysql_error()) $logger->write(mysql_error(), 'ERROR');
    }

    return $result;
  }

  function tep_db_perform($table, $data, $action = 'insert', $parameters = '', $link = 'db_link') {
    reset($data);
    if ($action == 'insert') {
      $query = 'insert into ' . $table . ' (';
      while (list($columns, ) = each($data)) {
        $query .= $columns . ', ';
      }
      $query = substr($query, 0, -2) . ') values (';
      reset($data);
      while (list(, $value) = each($data)) {
        switch ((string)$value) {
          case 'now()':
            $query .= 'now(), ';
            break;
          case 'null':
            $query .= 'null, ';
            break;
          default:
            $query .= '\'' . tep_db_input($value) . '\', ';
            break;
        }
      }
      $query = substr($query, 0, -2) . ')';
    } elseif ($action == 'update') {
      $query = 'update ' . $table . ' set ';
      while (list($columns, $value) = each($data)) {
        switch ((string)$value) {
          case 'now()':
            $query .= $columns . ' = now(), ';
            break;
          case 'null':
            $query .= $columns .= ' = null, ';
            break;
          default:
            $query .= $columns . ' = \'' . tep_db_input($value) . '\', ';
            break;
        }
      }
      $query = substr($query, 0, -2) . ' where ' . $parameters;
    }

    return tep_db_query($query, $link);
  }

  function tep_db_fetch_array($db_query) {
    return mysql_fetch_array($db_query, MYSQL_ASSOC);
  }

  function tep_db_result($result, $row, $field = '') {
    return mysql_result($result, $row, $field);
  }

  function tep_db_num_rows($db_query) {
    return mysql_num_rows($db_query);
  }

  function tep_db_data_seek($db_query, $row_number) {
    return mysql_data_seek($db_query, $row_number);
  }

  function tep_db_insert_id() {
    return mysql_insert_id();
  }

  function tep_db_free_result($db_query) {
    return mysql_free_result($db_query);
  }

  function tep_db_fetch_fields($db_query) {
    return mysql_fetch_field($db_query);
  }

  function tep_db_output($string) {
    return htmlspecialchars($string);
  }

  function tep_db_input($string) {
    return addslashes($string);
  }

  function tep_db_prepare_input($string) {
    if (is_string($string)) {
      return trim(stripslashes($string));
    } elseif (is_array($string)) {
      reset($string);
      while (list($key, $value) = each($string)) {
        $string[$key] = tep_db_prepare_input($value);
      }
      return $string;
    } else {
      return $string;
    }
  }
  
  
  
  
  // BOF Linkmatics attributes sets plus
  function jjg_db_attributeSets($arr_attributeSetID, $productID, $action, $arr_remove_sets = array(), $link = 'db_link'){

  	if( $action == 'update_product' || 'delete_product_confirm' ){
	    for($j=0; $j<count($arr_attributeSetID); $j++){
          if( empty($arr_attributeSetID[$j]) ){
  		    continue;
  		  }
	      $options_query = "SELECT pas.products_options_id
		    FROM products_attributes_sets pas
		    WHERE pas.products_attributes_sets_id = " . (int)$arr_attributeSetID[$j];
	    
		  $products_attributes_options_query = tep_db_query($options_query, $link);
      // Changed delete to only delete those options from product attributes that are currently in Attributes Sets - leaves existing options on product
		  // This could be done in single delete query but split with above select for now

		  while ($products_attributes_delete_options = tep_db_fetch_array($products_attributes_options_query)){  
 		    $delete_query = "
		      DELETE FROM products_attributes
		        WHERE products_id=" . $productID . "
			    AND options_id=" . $products_attributes_delete_options['products_options_id'] . " ";
  		    tep_db_query($delete_query, $link);
		  }
  		  $delete_query = "
		    DELETE FROM " . TABLE_PRODUCTS_ATTRIBUTES_SETS_TO_PRODUCTS . "
		     WHERE products_attributes_sets_id = " . $arr_attributeSetID[$j] . "
			 AND products_id = " . $productID;
  		  tep_db_query($delete_query, $link);
	  }
  	}
	//if you remove the product, then our work is done
  	if( $action == 'delete_product_confirm' ){
  		return;
  	}

	reset($arr_attributeSetID);
  	for($j=0; $j<count($arr_attributeSetID); $j++){

  		if( empty($arr_attributeSetID[$j]) ){
  		    continue;
  		}
		if( in_array($arr_attributeSetID[$j], $arr_remove_sets) ){
  		    continue;
		}

		$select_query = "select pas.products_options_id, pase.options_values_id, pase.options_values_price, pase.price_prefix, pase.sort_order
        FROM " . TABLE_PRODUCTS_ATTRIBUTES_SETS . " pas, " . TABLE_PRODUCTS_ATTRIBUTES_SETS_ELEMENTS . " pase 
		WHERE pas.products_attributes_sets_id = " . $arr_attributeSetID[$j] . "
		AND pase.products_attributes_sets_id = " . $arr_attributeSetID[$j] . " ";

		$products_attributes_sets_query = tep_db_query($select_query, $link);

		while ($products_attributes_sets_values = tep_db_fetch_array($products_attributes_sets_query)){
			  
		  $valOptions_id = $products_attributes_sets_values['products_options_id'];
		  $valOptions_values_id = $products_attributes_sets_values['options_values_id'];
		  $valOptions_values_price = $products_attributes_sets_values['options_values_price'];
		  $valPrice_prefix = $products_attributes_sets_values['price_prefix'];
		  
		  $insert_query = "insert into " . TABLE_PRODUCTS_ATTRIBUTES .
		    " (products_id, options_id, options_values_id, options_values_price, price_prefix) values ".
		    " (".$productID.",".$valOptions_id.",".$valOptions_values_id.",".$valOptions_values_price.",'".$valPrice_prefix."')";
		  tep_db_query($insert_query, $link);
		}
		//END OF FETCH WHILE LOOP

		$insert_query = "insert into ".TABLE_PRODUCTS_ATTRIBUTES_SETS_TO_PRODUCTS .
		" (products_attributes_sets_id, products_id) values (".$arr_attributeSetID[$j].",".$productID.")";
		tep_db_query($insert_query, $link);
        }
  }
  // EOF DB rewrite

  function jjg_db_getAttributeSetId($productID, $link = 'db_link'){
  	$arr_result = array();
  	if( !empty($productID) ){
	    $select_query = "select products_attributes_sets_id from products_attributes_sets_to_products where products_id=".$productID;
	    $products_attributes_sets_query = tep_db_query($select_query, $link);

    	    $i=0;
    	    while($rs = tep_db_fetch_array($products_attributes_sets_query) ){
    	    	$arr_result[$i] = $rs['products_attributes_sets_id'];
    	    	$i++;
    	    }
    	}

    	return $arr_result;
  }
  // EOF Linkmatics attributes sets plus
  
  
  
  
  
?>