<?php
/*
  $Id: abxModule.php,v 1.11 2007/11/12 18:32:51 auctionblox Exp $

  AuctionBlox, sell more, work less!
  http://www.auctionblox.com

  Copyright (c) 2004 AuctionBlox
*/

  class abxModule {

    function process()
    {
      return FALSE;
    }

    function display()
    {
      return FALSE;
    }

    function adminModules()
    {
      return array(
        'sales',
        'listings',
        'uploads',
        'uploader',
        'generator',
        'preview',
        'scheduler',
        'templates',
        'items',
        'shipping_fixed',
        'search',
        'editor',
        'popup_image',
        'jscookmenu',
        'profiles',
        'configure',
        'install',
        'inventory',
        'preferences',
        'auctionblox',
        'importer',
        'macros',
        'cron'
      );
    }

    function catalogModules()
    {
      return array(
        'abxn',
        'cron',
        'inventory',
        'catalog_checkout'
      );
    }

    function &moduleDisplay($module)
    {
      if(include(DIR_FS_ABX_MODULES . $module . '.php')) {

        $module = explode('_', $module);

        for($i=0,$n=count($module);$i<$n;$i++)

          $module[$i] = ucfirst($module[$i]);

        $module = 'abxModule_'.implode('_',$module);

        $module =  new $module;

        if (is_object($module) === true && is_subclass_of($module, 'abxModule') === true)

          return $module->display();

        else

          return FALSE;
      }

      return FALSE;
    }

    function &adminPage($module)
    {
      $module = in_array($module,abxModule::adminModules()) ? $module : 'auctionblox';

      return abxModule::moduleDisplay($module);
    }

    function &catalogPage($module)
    {
      $module = in_array($module,abxModule::catalogModules()) ? $module : 'catalog_checkout';

      return abxModule::moduleDisplay($module);
    }

  }//end class
?>
